# Fitness . users . dataSources

## Instance Methods

Returns the datasets Resource.

Creates a new data source that is unique across all data sources belonging to this user. The data stream ID field can be omitted and will be generated by the server with the correct format. The data stream ID is an ordered combination of some fields from the data source. In addition to the data source fields reflected into the data source ID, the developer project number that is authenticated when creating the data source is included. This developer project number is obfuscated when read by any other developer reading public data types.

Returns a data source identified by a data stream ID.

Lists all data sources that are visible to the developer, using the OAuth scopes provided. The list is not exhaustive: the user may have private data sources that are only visible to other developers or calls using other scopes.

Updates a given data source. It is an error to modify the data source's data stream ID, data type, type, stream name or device information apart from the device version. Changing these fields would require a new unique data stream ID and separate data source.

Updates a given data source. It is an error to modify the data source's data stream ID, data type, type, stream name or device information apart from the device version. Changing these fields would require a new unique data stream ID and separate data source.

### Method Details

`create(userId, body)`

    Creates a new data source that is unique across all data sources belonging to this user. The data stream ID field can be omitted and will be generated by the server with the correct format. The data stream ID is an ordered combination of some fields from the data source. In addition to the data source fields reflected into the data source ID, the developer project number that is authenticated when creating the data source is included. This developer project number is obfuscated when read by any other developer reading public data types.

    Args:
      userId: string, Create the data source for the person identified. Use me to indicate the authenticated user. Only me is supported at this time. (required)
      body: object, The request body. (required)
        The object takes the form of:

    { # Definition of a unique source of sensor data. Data sources can expose raw data coming from hardware sensors on local or companion devices. They can also expose derived data, created by transforming or merging other data sources. Multiple data sources can exist for the same data type. Every data point inserted into or read from this service has an associated data source.
          #
          # The data source contains enough information to uniquely identify its data, including the hardware device and the application that collected and/or transformed the data. It also holds useful metadata, such as the hardware and application versions, and the device type.
          #
          # Each data source produces a unique stream of data, with a unique identifier. Not all changes to data source affect the stream identifier, so that data collected by updated versions of the same application/device can still be considered to belong to the same data stream.
        "name": "A String", # An end-user visible name for this data source.
        "dataStreamName": "A String", # The stream name uniquely identifies this particular data source among other data sources of the same type from the same underlying producer. Setting the stream name is optional, but should be done whenever an application exposes two streams for the same data type, or when a device has two equivalent sensors.
        "dataType": { # See: google3/java/com/google/android/apps/heart/platform/api/DataType.java # The data type defines the schema for a stream of data being collected by, inserted into, or queried from the Fitness API.
          "field": [ # A field represents one dimension of a data type.
            { # In case of multi-dimensional data (such as an accelerometer with x, y, and z axes) each field represents one dimension. Each data type field has a unique name which identifies it. The field also defines the format of the data (int, float, etc.).
                #
                # This message is only instantiated in code and not used for wire comms or stored in any way.
              "optional": True or False,
              "name": "A String", # Defines the name and format of data. Unlike data type names, field names are not namespaced, and only need to be unique within the data type.
              "format": "A String", # The different supported formats for each field in a data type.
            },
          ],
          "name": "A String", # Each data type has a unique, namespaced, name. All data types in the com.google namespace are shared as part of the platform.
        },
        "application": { # See: google3/java/com/google/android/apps/heart/platform/api/Application.java # Information about an application which feeds sensor data into the platform.
          "packageName": "A String", # Package name for this application. This is used as a unique identifier when created by Android applications, but cannot be specified by REST clients. REST clients will have their developer project number reflected into the Data Source data stream IDs, instead of the packageName.
          "version": "A String", # Version of the application. You should update this field whenever the application changes in a way that affects the computation of the data.
          "name": "A String", # The name of this application. This is required for REST clients, but we do not enforce uniqueness of this name. It is provided as a matter of convenience for other developers who would like to identify which REST created an Application or Data Source.
          "detailsUrl": "A String", # An optional URI that can be used to link back to the application.
        },
        "device": { # Representation of an integrated device (such as a phone or a wearable) that can hold sensors. Each sensor is exposed as a data source. # Representation of an integrated device (such as a phone or a wearable) that can hold sensors.
            #
            # The main purpose of the device information contained in this class is to identify the hardware of a particular data source. This can be useful in different ways, including:
            # - Distinguishing two similar sensors on different devices (the step counter on two nexus 5 phones, for instance)
            # - Display the source of data to the user (by using the device make / model)
            # - Treat data differently depending on sensor type (accelerometers on a watch may give different patterns than those on a phone)
            # - Build different analysis models for each device/version.
          "model": "A String", # End-user visible model name for the device.
          "version": "A String", # Version string for the device hardware/software.
          "type": "A String", # A constant representing the type of the device.
          "uid": "A String", # The serial number or other unique ID for the hardware. This field is obfuscated when read by any REST or Android client that did not create the data source. Only the data source creator will see the uid field in clear and normal form.
          "manufacturer": "A String", # Manufacturer of the product/hardware.
        },
        "dataStreamId": "A String", # A unique identifier for the data stream produced by this data source. The identifier includes:
            #
            #
            # - The physical device's manufacturer, model, and serial number (UID).
            # - The application's package name or name. Package name is used when the data source was created by an Android application. The developer project number is used when the data source was created by a REST client.
            # - The data source's type.
            # - The data source's stream name.  Note that not all attributes of the data source are used as part of the stream identifier. In particular, the version of the hardware/the application isn't used. This allows us to preserve the same stream through version updates. This also means that two DataSource objects may represent the same data stream even if they're not equal.
            #
            # The exact format of the data stream ID created by an Android application is: type:dataType.name:application.packageName:device.manufacturer:device.model:device.uid:dataStreamName
            #
            # The exact format of the data stream ID created by a REST client is: type:dataType.name:developer project number:device.manufacturer:device.model:device.uid:dataStreamName
            #
            # When any of the optional fields that comprise of the data stream ID are blank, they will be omitted from the data stream ID. The minnimum viable data stream ID would be: type:dataType.name:developer project number
            #
            # Finally, the developer project number is obfuscated when read by any REST or Android client that did not create the data source. Only the data source creator will see the developer project number in clear and normal form.
        "type": "A String", # A constant describing the type of this data source. Indicates whether this data source produces raw or derived data.
      }

    Returns:
      An object of the form:

        { # Definition of a unique source of sensor data. Data sources can expose raw data coming from hardware sensors on local or companion devices. They can also expose derived data, created by transforming or merging other data sources. Multiple data sources can exist for the same data type. Every data point inserted into or read from this service has an associated data source.
            #
            # The data source contains enough information to uniquely identify its data, including the hardware device and the application that collected and/or transformed the data. It also holds useful metadata, such as the hardware and application versions, and the device type.
            #
            # Each data source produces a unique stream of data, with a unique identifier. Not all changes to data source affect the stream identifier, so that data collected by updated versions of the same application/device can still be considered to belong to the same data stream.
          "name": "A String", # An end-user visible name for this data source.
          "dataStreamName": "A String", # The stream name uniquely identifies this particular data source among other data sources of the same type from the same underlying producer. Setting the stream name is optional, but should be done whenever an application exposes two streams for the same data type, or when a device has two equivalent sensors.
          "dataType": { # See: google3/java/com/google/android/apps/heart/platform/api/DataType.java # The data type defines the schema for a stream of data being collected by, inserted into, or queried from the Fitness API.
            "field": [ # A field represents one dimension of a data type.
              { # In case of multi-dimensional data (such as an accelerometer with x, y, and z axes) each field represents one dimension. Each data type field has a unique name which identifies it. The field also defines the format of the data (int, float, etc.).
                  #
                  # This message is only instantiated in code and not used for wire comms or stored in any way.
                "optional": True or False,
                "name": "A String", # Defines the name and format of data. Unlike data type names, field names are not namespaced, and only need to be unique within the data type.
                "format": "A String", # The different supported formats for each field in a data type.
              },
            ],
            "name": "A String", # Each data type has a unique, namespaced, name. All data types in the com.google namespace are shared as part of the platform.
          },
          "application": { # See: google3/java/com/google/android/apps/heart/platform/api/Application.java # Information about an application which feeds sensor data into the platform.
            "packageName": "A String", # Package name for this application. This is used as a unique identifier when created by Android applications, but cannot be specified by REST clients. REST clients will have their developer project number reflected into the Data Source data stream IDs, instead of the packageName.
            "version": "A String", # Version of the application. You should update this field whenever the application changes in a way that affects the computation of the data.
            "name": "A String", # The name of this application. This is required for REST clients, but we do not enforce uniqueness of this name. It is provided as a matter of convenience for other developers who would like to identify which REST created an Application or Data Source.
            "detailsUrl": "A String", # An optional URI that can be used to link back to the application.
          },
          "device": { # Representation of an integrated device (such as a phone or a wearable) that can hold sensors. Each sensor is exposed as a data source. # Representation of an integrated device (such as a phone or a wearable) that can hold sensors.
              #
              # The main purpose of the device information contained in this class is to identify the hardware of a particular data source. This can be useful in different ways, including:
              # - Distinguishing two similar sensors on different devices (the step counter on two nexus 5 phones, for instance)
              # - Display the source of data to the user (by using the device make / model)
              # - Treat data differently depending on sensor type (accelerometers on a watch may give different patterns than those on a phone)
              # - Build different analysis models for each device/version.
            "model": "A String", # End-user visible model name for the device.
            "version": "A String", # Version string for the device hardware/software.
            "type": "A String", # A constant representing the type of the device.
            "uid": "A String", # The serial number or other unique ID for the hardware. This field is obfuscated when read by any REST or Android client that did not create the data source. Only the data source creator will see the uid field in clear and normal form.
            "manufacturer": "A String", # Manufacturer of the product/hardware.
          },
          "dataStreamId": "A String", # A unique identifier for the data stream produced by this data source. The identifier includes:
              #
              #
              # - The physical device's manufacturer, model, and serial number (UID).
              # - The application's package name or name. Package name is used when the data source was created by an Android application. The developer project number is used when the data source was created by a REST client.
              # - The data source's type.
              # - The data source's stream name.  Note that not all attributes of the data source are used as part of the stream identifier. In particular, the version of the hardware/the application isn't used. This allows us to preserve the same stream through version updates. This also means that two DataSource objects may represent the same data stream even if they're not equal.
              #
              # The exact format of the data stream ID created by an Android application is: type:dataType.name:application.packageName:device.manufacturer:device.model:device.uid:dataStreamName
              #
              # The exact format of the data stream ID created by a REST client is: type:dataType.name:developer project number:device.manufacturer:device.model:device.uid:dataStreamName
              #
              # When any of the optional fields that comprise of the data stream ID are blank, they will be omitted from the data stream ID. The minnimum viable data stream ID would be: type:dataType.name:developer project number
              #
              # Finally, the developer project number is obfuscated when read by any REST or Android client that did not create the data source. Only the data source creator will see the developer project number in clear and normal form.
          "type": "A String", # A constant describing the type of this data source. Indicates whether this data source produces raw or derived data.
        }

`get(userId, dataSourceId)`

    Returns a data source identified by a data stream ID.

    Args:
      userId: string, Retrieve a data source for the person identified. Use me to indicate the authenticated user. Only me is supported at this time. (required)
      dataSourceId: string, The data stream ID of the data source to retrieve. (required)

    Returns:
      An object of the form:

        { # Definition of a unique source of sensor data. Data sources can expose raw data coming from hardware sensors on local or companion devices. They can also expose derived data, created by transforming or merging other data sources. Multiple data sources can exist for the same data type. Every data point inserted into or read from this service has an associated data source.
            #
            # The data source contains enough information to uniquely identify its data, including the hardware device and the application that collected and/or transformed the data. It also holds useful metadata, such as the hardware and application versions, and the device type.
            #
            # Each data source produces a unique stream of data, with a unique identifier. Not all changes to data source affect the stream identifier, so that data collected by updated versions of the same application/device can still be considered to belong to the same data stream.
          "name": "A String", # An end-user visible name for this data source.
          "dataStreamName": "A String", # The stream name uniquely identifies this particular data source among other data sources of the same type from the same underlying producer. Setting the stream name is optional, but should be done whenever an application exposes two streams for the same data type, or when a device has two equivalent sensors.
          "dataType": { # See: google3/java/com/google/android/apps/heart/platform/api/DataType.java # The data type defines the schema for a stream of data being collected by, inserted into, or queried from the Fitness API.
            "field": [ # A field represents one dimension of a data type.
              { # In case of multi-dimensional data (such as an accelerometer with x, y, and z axes) each field represents one dimension. Each data type field has a unique name which identifies it. The field also defines the format of the data (int, float, etc.).
                  #
                  # This message is only instantiated in code and not used for wire comms or stored in any way.
                "optional": True or False,
                "name": "A String", # Defines the name and format of data. Unlike data type names, field names are not namespaced, and only need to be unique within the data type.
                "format": "A String", # The different supported formats for each field in a data type.
              },
            ],
            "name": "A String", # Each data type has a unique, namespaced, name. All data types in the com.google namespace are shared as part of the platform.
          },
          "application": { # See: google3/java/com/google/android/apps/heart/platform/api/Application.java # Information about an application which feeds sensor data into the platform.
            "packageName": "A String", # Package name for this application. This is used as a unique identifier when created by Android applications, but cannot be specified by REST clients. REST clients will have their developer project number reflected into the Data Source data stream IDs, instead of the packageName.
            "version": "A String", # Version of the application. You should update this field whenever the application changes in a way that affects the computation of the data.
            "name": "A String", # The name of this application. This is required for REST clients, but we do not enforce uniqueness of this name. It is provided as a matter of convenience for other developers who would like to identify which REST created an Application or Data Source.
            "detailsUrl": "A String", # An optional URI that can be used to link back to the application.
          },
          "device": { # Representation of an integrated device (such as a phone or a wearable) that can hold sensors. Each sensor is exposed as a data source. # Representation of an integrated device (such as a phone or a wearable) that can hold sensors.
              #
              # The main purpose of the device information contained in this class is to identify the hardware of a particular data source. This can be useful in different ways, including:
              # - Distinguishing two similar sensors on different devices (the step counter on two nexus 5 phones, for instance)
              # - Display the source of data to the user (by using the device make / model)
              # - Treat data differently depending on sensor type (accelerometers on a watch may give different patterns than those on a phone)
              # - Build different analysis models for each device/version.
            "model": "A String", # End-user visible model name for the device.
            "version": "A String", # Version string for the device hardware/software.
            "type": "A String", # A constant representing the type of the device.
            "uid": "A String", # The serial number or other unique ID for the hardware. This field is obfuscated when read by any REST or Android client that did not create the data source. Only the data source creator will see the uid field in clear and normal form.
            "manufacturer": "A String", # Manufacturer of the product/hardware.
          },
          "dataStreamId": "A String", # A unique identifier for the data stream produced by this data source. The identifier includes:
              #
              #
              # - The physical device's manufacturer, model, and serial number (UID).
              # - The application's package name or name. Package name is used when the data source was created by an Android application. The developer project number is used when the data source was created by a REST client.
              # - The data source's type.
              # - The data source's stream name.  Note that not all attributes of the data source are used as part of the stream identifier. In particular, the version of the hardware/the application isn't used. This allows us to preserve the same stream through version updates. This also means that two DataSource objects may represent the same data stream even if they're not equal.
              #
              # The exact format of the data stream ID created by an Android application is: type:dataType.name:application.packageName:device.manufacturer:device.model:device.uid:dataStreamName
              #
              # The exact format of the data stream ID created by a REST client is: type:dataType.name:developer project number:device.manufacturer:device.model:device.uid:dataStreamName
              #
              # When any of the optional fields that comprise of the data stream ID are blank, they will be omitted from the data stream ID. The minnimum viable data stream ID would be: type:dataType.name:developer project number
              #
              # Finally, the developer project number is obfuscated when read by any REST or Android client that did not create the data source. Only the data source creator will see the developer project number in clear and normal form.
          "type": "A String", # A constant describing the type of this data source. Indicates whether this data source produces raw or derived data.
        }

`list(userId, dataTypeName=None)`

    Lists all data sources that are visible to the developer, using the OAuth scopes provided. The list is not exhaustive: the user may have private data sources that are only visible to other developers or calls using other scopes.

    Args:
      userId: string, List data sources for the person identified. Use me to indicate the authenticated user. Only me is supported at this time. (required)
      dataTypeName: string, The names of data types to include in the list. If not specified, all data sources will be returned. (repeated)

    Returns:
      An object of the form:

        {
        "dataSource": [ # A previously created data source.
          { # Definition of a unique source of sensor data. Data sources can expose raw data coming from hardware sensors on local or companion devices. They can also expose derived data, created by transforming or merging other data sources. Multiple data sources can exist for the same data type. Every data point inserted into or read from this service has an associated data source.
                #
                # The data source contains enough information to uniquely identify its data, including the hardware device and the application that collected and/or transformed the data. It also holds useful metadata, such as the hardware and application versions, and the device type.
                #
                # Each data source produces a unique stream of data, with a unique identifier. Not all changes to data source affect the stream identifier, so that data collected by updated versions of the same application/device can still be considered to belong to the same data stream.
              "name": "A String", # An end-user visible name for this data source.
              "dataStreamName": "A String", # The stream name uniquely identifies this particular data source among other data sources of the same type from the same underlying producer. Setting the stream name is optional, but should be done whenever an application exposes two streams for the same data type, or when a device has two equivalent sensors.
              "dataType": { # See: google3/java/com/google/android/apps/heart/platform/api/DataType.java # The data type defines the schema for a stream of data being collected by, inserted into, or queried from the Fitness API.
                "field": [ # A field represents one dimension of a data type.
                  { # In case of multi-dimensional data (such as an accelerometer with x, y, and z axes) each field represents one dimension. Each data type field has a unique name which identifies it. The field also defines the format of the data (int, float, etc.).
                      #
                      # This message is only instantiated in code and not used for wire comms or stored in any way.
                    "optional": True or False,
                    "name": "A String", # Defines the name and format of data. Unlike data type names, field names are not namespaced, and only need to be unique within the data type.
                    "format": "A String", # The different supported formats for each field in a data type.
                  },
                ],
                "name": "A String", # Each data type has a unique, namespaced, name. All data types in the com.google namespace are shared as part of the platform.
              },
              "application": { # See: google3/java/com/google/android/apps/heart/platform/api/Application.java # Information about an application which feeds sensor data into the platform.
                "packageName": "A String", # Package name for this application. This is used as a unique identifier when created by Android applications, but cannot be specified by REST clients. REST clients will have their developer project number reflected into the Data Source data stream IDs, instead of the packageName.
                "version": "A String", # Version of the application. You should update this field whenever the application changes in a way that affects the computation of the data.
                "name": "A String", # The name of this application. This is required for REST clients, but we do not enforce uniqueness of this name. It is provided as a matter of convenience for other developers who would like to identify which REST created an Application or Data Source.
                "detailsUrl": "A String", # An optional URI that can be used to link back to the application.
              },
              "device": { # Representation of an integrated device (such as a phone or a wearable) that can hold sensors. Each sensor is exposed as a data source. # Representation of an integrated device (such as a phone or a wearable) that can hold sensors.
                  #
                  # The main purpose of the device information contained in this class is to identify the hardware of a particular data source. This can be useful in different ways, including:
                  # - Distinguishing two similar sensors on different devices (the step counter on two nexus 5 phones, for instance)
                  # - Display the source of data to the user (by using the device make / model)
                  # - Treat data differently depending on sensor type (accelerometers on a watch may give different patterns than those on a phone)
                  # - Build different analysis models for each device/version.
                "model": "A String", # End-user visible model name for the device.
                "version": "A String", # Version string for the device hardware/software.
                "type": "A String", # A constant representing the type of the device.
                "uid": "A String", # The serial number or other unique ID for the hardware. This field is obfuscated when read by any REST or Android client that did not create the data source. Only the data source creator will see the uid field in clear and normal form.
                "manufacturer": "A String", # Manufacturer of the product/hardware.
              },
              "dataStreamId": "A String", # A unique identifier for the data stream produced by this data source. The identifier includes:
                  #
                  #
                  # - The physical device's manufacturer, model, and serial number (UID).
                  # - The application's package name or name. Package name is used when the data source was created by an Android application. The developer project number is used when the data source was created by a REST client.
                  # - The data source's type.
                  # - The data source's stream name.  Note that not all attributes of the data source are used as part of the stream identifier. In particular, the version of the hardware/the application isn't used. This allows us to preserve the same stream through version updates. This also means that two DataSource objects may represent the same data stream even if they're not equal.
                  #
                  # The exact format of the data stream ID created by an Android application is: type:dataType.name:application.packageName:device.manufacturer:device.model:device.uid:dataStreamName
                  #
                  # The exact format of the data stream ID created by a REST client is: type:dataType.name:developer project number:device.manufacturer:device.model:device.uid:dataStreamName
                  #
                  # When any of the optional fields that comprise of the data stream ID are blank, they will be omitted from the data stream ID. The minnimum viable data stream ID would be: type:dataType.name:developer project number
                  #
                  # Finally, the developer project number is obfuscated when read by any REST or Android client that did not create the data source. Only the data source creator will see the developer project number in clear and normal form.
              "type": "A String", # A constant describing the type of this data source. Indicates whether this data source produces raw or derived data.
            },
        ],
      }

`patch(userId, dataSourceId, body)`

    Updates a given data source. It is an error to modify the data source's data stream ID, data type, type, stream name or device information apart from the device version. Changing these fields would require a new unique data stream ID and separate data source.

    Data sources are identified by their data stream ID. This method supports patch semantics.

    Args:
      userId: string, Update the data source for the person identified. Use me to indicate the authenticated user. Only me is supported at this time. (required)
      dataSourceId: string, The data stream ID of the data source to update. (required)
      body: object, The request body. (required)
        The object takes the form of:

    { # Definition of a unique source of sensor data. Data sources can expose raw data coming from hardware sensors on local or companion devices. They can also expose derived data, created by transforming or merging other data sources. Multiple data sources can exist for the same data type. Every data point inserted into or read from this service has an associated data source.
          #
          # The data source contains enough information to uniquely identify its data, including the hardware device and the application that collected and/or transformed the data. It also holds useful metadata, such as the hardware and application versions, and the device type.
          #
          # Each data source produces a unique stream of data, with a unique identifier. Not all changes to data source affect the stream identifier, so that data collected by updated versions of the same application/device can still be considered to belong to the same data stream.
        "name": "A String", # An end-user visible name for this data source.
        "dataStreamName": "A String", # The stream name uniquely identifies this particular data source among other data sources of the same type from the same underlying producer. Setting the stream name is optional, but should be done whenever an application exposes two streams for the same data type, or when a device has two equivalent sensors.
        "dataType": { # See: google3/java/com/google/android/apps/heart/platform/api/DataType.java # The data type defines the schema for a stream of data being collected by, inserted into, or queried from the Fitness API.
          "field": [ # A field represents one dimension of a data type.
            { # In case of multi-dimensional data (such as an accelerometer with x, y, and z axes) each field represents one dimension. Each data type field has a unique name which identifies it. The field also defines the format of the data (int, float, etc.).
                #
                # This message is only instantiated in code and not used for wire comms or stored in any way.
              "optional": True or False,
              "name": "A String", # Defines the name and format of data. Unlike data type names, field names are not namespaced, and only need to be unique within the data type.
              "format": "A String", # The different supported formats for each field in a data type.
            },
          ],
          "name": "A String", # Each data type has a unique, namespaced, name. All data types in the com.google namespace are shared as part of the platform.
        },
        "application": { # See: google3/java/com/google/android/apps/heart/platform/api/Application.java # Information about an application which feeds sensor data into the platform.
          "packageName": "A String", # Package name for this application. This is used as a unique identifier when created by Android applications, but cannot be specified by REST clients. REST clients will have their developer project number reflected into the Data Source data stream IDs, instead of the packageName.
          "version": "A String", # Version of the application. You should update this field whenever the application changes in a way that affects the computation of the data.
          "name": "A String", # The name of this application. This is required for REST clients, but we do not enforce uniqueness of this name. It is provided as a matter of convenience for other developers who would like to identify which REST created an Application or Data Source.
          "detailsUrl": "A String", # An optional URI that can be used to link back to the application.
        },
        "device": { # Representation of an integrated device (such as a phone or a wearable) that can hold sensors. Each sensor is exposed as a data source. # Representation of an integrated device (such as a phone or a wearable) that can hold sensors.
            #
            # The main purpose of the device information contained in this class is to identify the hardware of a particular data source. This can be useful in different ways, including:
            # - Distinguishing two similar sensors on different devices (the step counter on two nexus 5 phones, for instance)
            # - Display the source of data to the user (by using the device make / model)
            # - Treat data differently depending on sensor type (accelerometers on a watch may give different patterns than those on a phone)
            # - Build different analysis models for each device/version.
          "model": "A String", # End-user visible model name for the device.
          "version": "A String", # Version string for the device hardware/software.
          "type": "A String", # A constant representing the type of the device.
          "uid": "A String", # The serial number or other unique ID for the hardware. This field is obfuscated when read by any REST or Android client that did not create the data source. Only the data source creator will see the uid field in clear and normal form.
          "manufacturer": "A String", # Manufacturer of the product/hardware.
        },
        "dataStreamId": "A String", # A unique identifier for the data stream produced by this data source. The identifier includes:
            #
            #
            # - The physical device's manufacturer, model, and serial number (UID).
            # - The application's package name or name. Package name is used when the data source was created by an Android application. The developer project number is used when the data source was created by a REST client.
            # - The data source's type.
            # - The data source's stream name.  Note that not all attributes of the data source are used as part of the stream identifier. In particular, the version of the hardware/the application isn't used. This allows us to preserve the same stream through version updates. This also means that two DataSource objects may represent the same data stream even if they're not equal.
            #
            # The exact format of the data stream ID created by an Android application is: type:dataType.name:application.packageName:device.manufacturer:device.model:device.uid:dataStreamName
            #
            # The exact format of the data stream ID created by a REST client is: type:dataType.name:developer project number:device.manufacturer:device.model:device.uid:dataStreamName
            #
            # When any of the optional fields that comprise of the data stream ID are blank, they will be omitted from the data stream ID. The minnimum viable data stream ID would be: type:dataType.name:developer project number
            #
            # Finally, the developer project number is obfuscated when read by any REST or Android client that did not create the data source. Only the data source creator will see the developer project number in clear and normal form.
        "type": "A String", # A constant describing the type of this data source. Indicates whether this data source produces raw or derived data.
      }

    Returns:
      An object of the form:

        { # Definition of a unique source of sensor data. Data sources can expose raw data coming from hardware sensors on local or companion devices. They can also expose derived data, created by transforming or merging other data sources. Multiple data sources can exist for the same data type. Every data point inserted into or read from this service has an associated data source.
            #
            # The data source contains enough information to uniquely identify its data, including the hardware device and the application that collected and/or transformed the data. It also holds useful metadata, such as the hardware and application versions, and the device type.
            #
            # Each data source produces a unique stream of data, with a unique identifier. Not all changes to data source affect the stream identifier, so that data collected by updated versions of the same application/device can still be considered to belong to the same data stream.
          "name": "A String", # An end-user visible name for this data source.
          "dataStreamName": "A String", # The stream name uniquely identifies this particular data source among other data sources of the same type from the same underlying producer. Setting the stream name is optional, but should be done whenever an application exposes two streams for the same data type, or when a device has two equivalent sensors.
          "dataType": { # See: google3/java/com/google/android/apps/heart/platform/api/DataType.java # The data type defines the schema for a stream of data being collected by, inserted into, or queried from the Fitness API.
            "field": [ # A field represents one dimension of a data type.
              { # In case of multi-dimensional data (such as an accelerometer with x, y, and z axes) each field represents one dimension. Each data type field has a unique name which identifies it. The field also defines the format of the data (int, float, etc.).
                  #
                  # This message is only instantiated in code and not used for wire comms or stored in any way.
                "optional": True or False,
                "name": "A String", # Defines the name and format of data. Unlike data type names, field names are not namespaced, and only need to be unique within the data type.
                "format": "A String", # The different supported formats for each field in a data type.
              },
            ],
            "name": "A String", # Each data type has a unique, namespaced, name. All data types in the com.google namespace are shared as part of the platform.
          },
          "application": { # See: google3/java/com/google/android/apps/heart/platform/api/Application.java # Information about an application which feeds sensor data into the platform.
            "packageName": "A String", # Package name for this application. This is used as a unique identifier when created by Android applications, but cannot be specified by REST clients. REST clients will have their developer project number reflected into the Data Source data stream IDs, instead of the packageName.
            "version": "A String", # Version of the application. You should update this field whenever the application changes in a way that affects the computation of the data.
            "name": "A String", # The name of this application. This is required for REST clients, but we do not enforce uniqueness of this name. It is provided as a matter of convenience for other developers who would like to identify which REST created an Application or Data Source.
            "detailsUrl": "A String", # An optional URI that can be used to link back to the application.
          },
          "device": { # Representation of an integrated device (such as a phone or a wearable) that can hold sensors. Each sensor is exposed as a data source. # Representation of an integrated device (such as a phone or a wearable) that can hold sensors.
              #
              # The main purpose of the device information contained in this class is to identify the hardware of a particular data source. This can be useful in different ways, including:
              # - Distinguishing two similar sensors on different devices (the step counter on two nexus 5 phones, for instance)
              # - Display the source of data to the user (by using the device make / model)
              # - Treat data differently depending on sensor type (accelerometers on a watch may give different patterns than those on a phone)
              # - Build different analysis models for each device/version.
            "model": "A String", # End-user visible model name for the device.
            "version": "A String", # Version string for the device hardware/software.
            "type": "A String", # A constant representing the type of the device.
            "uid": "A String", # The serial number or other unique ID for the hardware. This field is obfuscated when read by any REST or Android client that did not create the data source. Only the data source creator will see the uid field in clear and normal form.
            "manufacturer": "A String", # Manufacturer of the product/hardware.
          },
          "dataStreamId": "A String", # A unique identifier for the data stream produced by this data source. The identifier includes:
              #
              #
              # - The physical device's manufacturer, model, and serial number (UID).
              # - The application's package name or name. Package name is used when the data source was created by an Android application. The developer project number is used when the data source was created by a REST client.
              # - The data source's type.
              # - The data source's stream name.  Note that not all attributes of the data source are used as part of the stream identifier. In particular, the version of the hardware/the application isn't used. This allows us to preserve the same stream through version updates. This also means that two DataSource objects may represent the same data stream even if they're not equal.
              #
              # The exact format of the data stream ID created by an Android application is: type:dataType.name:application.packageName:device.manufacturer:device.model:device.uid:dataStreamName
              #
              # The exact format of the data stream ID created by a REST client is: type:dataType.name:developer project number:device.manufacturer:device.model:device.uid:dataStreamName
              #
              # When any of the optional fields that comprise of the data stream ID are blank, they will be omitted from the data stream ID. The minnimum viable data stream ID would be: type:dataType.name:developer project number
              #
              # Finally, the developer project number is obfuscated when read by any REST or Android client that did not create the data source. Only the data source creator will see the developer project number in clear and normal form.
          "type": "A String", # A constant describing the type of this data source. Indicates whether this data source produces raw or derived data.
        }

`update(userId, dataSourceId, body)`

    Updates a given data source. It is an error to modify the data source's data stream ID, data type, type, stream name or device information apart from the device version. Changing these fields would require a new unique data stream ID and separate data source.

    Data sources are identified by their data stream ID.

    Args:
      userId: string, Update the data source for the person identified. Use me to indicate the authenticated user. Only me is supported at this time. (required)
      dataSourceId: string, The data stream ID of the data source to update. (required)
      body: object, The request body. (required)
        The object takes the form of:

    { # Definition of a unique source of sensor data. Data sources can expose raw data coming from hardware sensors on local or companion devices. They can also expose derived data, created by transforming or merging other data sources. Multiple data sources can exist for the same data type. Every data point inserted into or read from this service has an associated data source.
          #
          # The data source contains enough information to uniquely identify its data, including the hardware device and the application that collected and/or transformed the data. It also holds useful metadata, such as the hardware and application versions, and the device type.
          #
          # Each data source produces a unique stream of data, with a unique identifier. Not all changes to data source affect the stream identifier, so that data collected by updated versions of the same application/device can still be considered to belong to the same data stream.
        "name": "A String", # An end-user visible name for this data source.
        "dataStreamName": "A String", # The stream name uniquely identifies this particular data source among other data sources of the same type from the same underlying producer. Setting the stream name is optional, but should be done whenever an application exposes two streams for the same data type, or when a device has two equivalent sensors.
        "dataType": { # See: google3/java/com/google/android/apps/heart/platform/api/DataType.java # The data type defines the schema for a stream of data being collected by, inserted into, or queried from the Fitness API.
          "field": [ # A field represents one dimension of a data type.
            { # In case of multi-dimensional data (such as an accelerometer with x, y, and z axes) each field represents one dimension. Each data type field has a unique name which identifies it. The field also defines the format of the data (int, float, etc.).
                #
                # This message is only instantiated in code and not used for wire comms or stored in any way.
              "optional": True or False,
              "name": "A String", # Defines the name and format of data. Unlike data type names, field names are not namespaced, and only need to be unique within the data type.
              "format": "A String", # The different supported formats for each field in a data type.
            },
          ],
          "name": "A String", # Each data type has a unique, namespaced, name. All data types in the com.google namespace are shared as part of the platform.
        },
        "application": { # See: google3/java/com/google/android/apps/heart/platform/api/Application.java # Information about an application which feeds sensor data into the platform.
          "packageName": "A String", # Package name for this application. This is used as a unique identifier when created by Android applications, but cannot be specified by REST clients. REST clients will have their developer project number reflected into the Data Source data stream IDs, instead of the packageName.
          "version": "A String", # Version of the application. You should update this field whenever the application changes in a way that affects the computation of the data.
          "name": "A String", # The name of this application. This is required for REST clients, but we do not enforce uniqueness of this name. It is provided as a matter of convenience for other developers who would like to identify which REST created an Application or Data Source.
          "detailsUrl": "A String", # An optional URI that can be used to link back to the application.
        },
        "device": { # Representation of an integrated device (such as a phone or a wearable) that can hold sensors. Each sensor is exposed as a data source. # Representation of an integrated device (such as a phone or a wearable) that can hold sensors.
            #
            # The main purpose of the device information contained in this class is to identify the hardware of a particular data source. This can be useful in different ways, including:
            # - Distinguishing two similar sensors on different devices (the step counter on two nexus 5 phones, for instance)
            # - Display the source of data to the user (by using the device make / model)
            # - Treat data differently depending on sensor type (accelerometers on a watch may give different patterns than those on a phone)
            # - Build different analysis models for each device/version.
          "model": "A String", # End-user visible model name for the device.
          "version": "A String", # Version string for the device hardware/software.
          "type": "A String", # A constant representing the type of the device.
          "uid": "A String", # The serial number or other unique ID for the hardware. This field is obfuscated when read by any REST or Android client that did not create the data source. Only the data source creator will see the uid field in clear and normal form.
          "manufacturer": "A String", # Manufacturer of the product/hardware.
        },
        "dataStreamId": "A String", # A unique identifier for the data stream produced by this data source. The identifier includes:
            #
            #
            # - The physical device's manufacturer, model, and serial number (UID).
            # - The application's package name or name. Package name is used when the data source was created by an Android application. The developer project number is used when the data source was created by a REST client.
            # - The data source's type.
            # - The data source's stream name.  Note that not all attributes of the data source are used as part of the stream identifier. In particular, the version of the hardware/the application isn't used. This allows us to preserve the same stream through version updates. This also means that two DataSource objects may represent the same data stream even if they're not equal.
            #
            # The exact format of the data stream ID created by an Android application is: type:dataType.name:application.packageName:device.manufacturer:device.model:device.uid:dataStreamName
            #
            # The exact format of the data stream ID created by a REST client is: type:dataType.name:developer project number:device.manufacturer:device.model:device.uid:dataStreamName
            #
            # When any of the optional fields that comprise of the data stream ID are blank, they will be omitted from the data stream ID. The minnimum viable data stream ID would be: type:dataType.name:developer project number
            #
            # Finally, the developer project number is obfuscated when read by any REST or Android client that did not create the data source. Only the data source creator will see the developer project number in clear and normal form.
        "type": "A String", # A constant describing the type of this data source. Indicates whether this data source produces raw or derived data.
      }

    Returns:
      An object of the form:

        { # Definition of a unique source of sensor data. Data sources can expose raw data coming from hardware sensors on local or companion devices. They can also expose derived data, created by transforming or merging other data sources. Multiple data sources can exist for the same data type. Every data point inserted into or read from this service has an associated data source.
            #
            # The data source contains enough information to uniquely identify its data, including the hardware device and the application that collected and/or transformed the data. It also holds useful metadata, such as the hardware and application versions, and the device type.
            #
            # Each data source produces a unique stream of data, with a unique identifier. Not all changes to data source affect the stream identifier, so that data collected by updated versions of the same application/device can still be considered to belong to the same data stream.
          "name": "A String", # An end-user visible name for this data source.
          "dataStreamName": "A String", # The stream name uniquely identifies this particular data source among other data sources of the same type from the same underlying producer. Setting the stream name is optional, but should be done whenever an application exposes two streams for the same data type, or when a device has two equivalent sensors.
          "dataType": { # See: google3/java/com/google/android/apps/heart/platform/api/DataType.java # The data type defines the schema for a stream of data being collected by, inserted into, or queried from the Fitness API.
            "field": [ # A field represents one dimension of a data type.
              { # In case of multi-dimensional data (such as an accelerometer with x, y, and z axes) each field represents one dimension. Each data type field has a unique name which identifies it. The field also defines the format of the data (int, float, etc.).
                  #
                  # This message is only instantiated in code and not used for wire comms or stored in any way.
                "optional": True or False,
                "name": "A String", # Defines the name and format of data. Unlike data type names, field names are not namespaced, and only need to be unique within the data type.
                "format": "A String", # The different supported formats for each field in a data type.
              },
            ],
            "name": "A String", # Each data type has a unique, namespaced, name. All data types in the com.google namespace are shared as part of the platform.
          },
          "application": { # See: google3/java/com/google/android/apps/heart/platform/api/Application.java # Information about an application which feeds sensor data into the platform.
            "packageName": "A String", # Package name for this application. This is used as a unique identifier when created by Android applications, but cannot be specified by REST clients. REST clients will have their developer project number reflected into the Data Source data stream IDs, instead of the packageName.
            "version": "A String", # Version of the application. You should update this field whenever the application changes in a way that affects the computation of the data.
            "name": "A String", # The name of this application. This is required for REST clients, but we do not enforce uniqueness of this name. It is provided as a matter of convenience for other developers who would like to identify which REST created an Application or Data Source.
            "detailsUrl": "A String", # An optional URI that can be used to link back to the application.
          },
          "device": { # Representation of an integrated device (such as a phone or a wearable) that can hold sensors. Each sensor is exposed as a data source. # Representation of an integrated device (such as a phone or a wearable) that can hold sensors.
              #
              # The main purpose of the device information contained in this class is to identify the hardware of a particular data source. This can be useful in different ways, including:
              # - Distinguishing two similar sensors on different devices (the step counter on two nexus 5 phones, for instance)
              # - Display the source of data to the user (by using the device make / model)
              # - Treat data differently depending on sensor type (accelerometers on a watch may give different patterns than those on a phone)
              # - Build different analysis models for each device/version.
            "model": "A String", # End-user visible model name for the device.
            "version": "A String", # Version string for the device hardware/software.
            "type": "A String", # A constant representing the type of the device.
            "uid": "A String", # The serial number or other unique ID for the hardware. This field is obfuscated when read by any REST or Android client that did not create the data source. Only the data source creator will see the uid field in clear and normal form.
            "manufacturer": "A String", # Manufacturer of the product/hardware.
          },
          "dataStreamId": "A String", # A unique identifier for the data stream produced by this data source. The identifier includes:
              #
              #
              # - The physical device's manufacturer, model, and serial number (UID).
              # - The application's package name or name. Package name is used when the data source was created by an Android application. The developer project number is used when the data source was created by a REST client.
              # - The data source's type.
              # - The data source's stream name.  Note that not all attributes of the data source are used as part of the stream identifier. In particular, the version of the hardware/the application isn't used. This allows us to preserve the same stream through version updates. This also means that two DataSource objects may represent the same data stream even if they're not equal.
              #
              # The exact format of the data stream ID created by an Android application is: type:dataType.name:application.packageName:device.manufacturer:device.model:device.uid:dataStreamName
              #
              # The exact format of the data stream ID created by a REST client is: type:dataType.name:developer project number:device.manufacturer:device.model:device.uid:dataStreamName
              #
              # When any of the optional fields that comprise of the data stream ID are blank, they will be omitted from the data stream ID. The minnimum viable data stream ID would be: type:dataType.name:developer project number
              #
              # Finally, the developer project number is obfuscated when read by any REST or Android client that did not create the data source. Only the data source creator will see the developer project number in clear and normal form.
          "type": "A String", # A constant describing the type of this data source. Indicates whether this data source produces raw or derived data.
        }